// PlayMidi.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "resource.h"
#include "COMMDLG.h"
#include "mmsystem.h"

BOOL FAR PASCAL	DlgProc(HWND hDlg,UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK	MainWndProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
static DWORD		MENUID_START;
static HANDLE		H_MODULE = NULL;
static HWND			g_hwnd=NULL;                           
static HMENU		MENU = NULL;
static BOOL			AUTO_LOOP;
static const char * INIFILE;
#define MID_OPEN	1
#define MID_PLAY	2
#define MID_PAUSE	3
#define MID_STOP	4
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	 H_MODULE = hModule;
    return TRUE;
}
LRESULT CALLBACK MainWndProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   switch (msg)
		{
		case MM_MCINOTIFY:
			{
			if (wParam == MCI_NOTIFY_SUCCESSFUL)
				{
				if (AUTO_LOOP)
					mciSendString("play MUSIC from 0 notify",NULL,0,g_hwnd);
					else
					{
					mciSendString("seek MUSIC to start",NULL,0,0);
					EnableMenuItem(MENU,MENUID_START+MID_PLAY,MF_BYCOMMAND | MF_ENABLED);
					EnableMenuItem(MENU,MENUID_START+MID_PAUSE,MF_BYCOMMAND | MF_GRAYED);
					EnableMenuItem(MENU,MENUID_START+MID_STOP,MF_BYCOMMAND | MF_GRAYED);
					}
				}
			}
			return TRUE;
		}
	return DefWindowProc(hwnd, msg, wParam, lParam);
} 
BOOL InitApplication (HINSTANCE hinst)
{
   WNDCLASS wc;

   wc.style = CS_DBLCLKS;
   wc.lpfnWndProc = MainWndProc;
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   wc.hInstance = hinst;
   wc.hIcon = NULL;
   wc.hCursor = NULL;
   wc.hbrBackground = NULL;
   wc.lpszMenuName = NULL;
   wc.lpszClassName = "PlayMidiClass";
     
   return RegisterClass(&wc);
 }
BOOL InitInstance (HINSTANCE hinst, int nCmdShow)
{
   g_hwnd = CreateWindow("PlayMidiClass", "",
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       40, 20,
                       NULL, NULL, hinst, NULL);
   if (!g_hwnd)
      return FALSE;
   return TRUE;
}
extern "C" _declspec (dllexport) int Detect()	{	return NULL;	}
extern "C" _declspec (dllexport) int GetVer()	{	return 0x10011000;	}
extern "C" _declspec (dllexport) const char * Copyright()	{	return "";	}
extern "C" _declspec (dllexport) const char * GetTitle()		{	return "Midi";	}
extern "C" _declspec (dllexport) 
HWND AutoExec(const char * inifile,HWND PWin,void * MFC_Pwin,long a,int MessageStart)
{
   INIFILE = inifile;
   AUTO_LOOP =  GetPrivateProfileInt("MIDI","AutoLoop",0,INIFILE);
   if (!InitApplication((HINSTANCE)H_MODULE))
      return (FALSE);
   if (!InitInstance((HINSTANCE)H_MODULE,FALSE))
      return (FALSE);
	HMENU hMenu = GetMenu(PWin);
	MENUID_START = MessageStart;
	if (hMenu)
		{
		MENUITEMINFO MenuItem;
		MenuItem.cbSize = sizeof(MenuItem);
		MenuItem.fMask = MIIM_SUBMENU | MIIM_TYPE;
		MenuItem.fType = MFT_STRING ;
		MenuItem.dwTypeData = "MIDI";
		MenuItem.cch = 4;		
		MENU = MenuItem.hSubMenu = LoadMenu((HINSTANCE)H_MODULE,MAKEINTRESOURCE(IDR_MENU));
		InsertMenuItem(hMenu,4,TRUE,&MenuItem);
		MenuItem.fMask = MIIM_ID;
		MenuItem.wID = MENUID_START+MID_OPEN;
		SetMenuItemInfo(MenuItem.hSubMenu,ID_MIDI_OPEN,FALSE,&MenuItem);
		MenuItem.wID = MENUID_START+MID_PLAY;
		SetMenuItemInfo(MenuItem.hSubMenu,ID_MIDI_PLAY,FALSE,&MenuItem);
		MenuItem.wID = MENUID_START+MID_PAUSE;
		SetMenuItemInfo(MenuItem.hSubMenu,ID_MIDI_PAUSE,FALSE,&MenuItem);
		MenuItem.wID = MENUID_START+MID_STOP;
		SetMenuItemInfo(MenuItem.hSubMenu,ID_MIDI_STOP,FALSE,&MenuItem);
		EnableMenuItem(MENU,MENUID_START+MID_PAUSE,MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(MENU,MENUID_START+MID_STOP,MF_BYCOMMAND | MF_GRAYED);
		DrawMenuBar(PWin);
		}
	return g_hwnd;
}

int OpenMidi(HWND ParentWin,char * FileName)
{
		OPENFILENAME ofn;
		ZeroMemory(&ofn,sizeof(ofn));
		char Path[4096];
		GetPrivateProfileString("MIDI","PATH","",Path,4096,INIFILE);
		char szFilter[]="Midi ļ(*.Mid)\0*.Mid\0";
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = ParentWin;
		ofn.lpstrFilter = szFilter;
		ofn.lpstrCustomFilter = NULL;
		ofn.nMaxCustFilter =0;
		ofn.nFilterIndex = 1;
		ofn.lpstrTitle = "Midiļ";
		ofn.lpstrInitialDir = Path;
		ofn.nMaxFileTitle = 12;
		ofn.lpstrFile = FileName;
		ofn.nMaxFile = 4096;
		ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_EXPLORER;
		int Ret = GetOpenFileName(&ofn);
		if (Ret==0)
			return FALSE;
		if (mciSendString("close all",NULL,0,0)!=0)
			return FALSE;
		mciSendString("close MUSIC",NULL,0,0);
		char MIDI_FileName[4096+128];
		wsprintf(MIDI_FileName,"open %s type sequencer alias MUSIC",FileName);
		mciSendString(MIDI_FileName,NULL,0,0);
		WritePrivateProfileString("MIDI","PATH",FileName,INIFILE);
 		return TRUE;
}

extern "C" _declspec (dllexport) 
int Run(HWND ParentWin,
			void * MFC_ParentWin,
			int wParam,
			const char * NowChar,const RECT * lpRect,
			const char * MainChar,int FileLen,
			int KBegin,int KEnd,
			POINT * lpPoint,
			char * lpFileName)
{
 static char FileName[4096] = {0};
 switch(wParam - MENUID_START)
	{
	case MID_OPEN://Open
		if (OpenMidi(ParentWin,FileName)==FALSE)
			break;
	case MID_PLAY://Play
		if (FileName[0]==0)
			if (OpenMidi(ParentWin,FileName)==FALSE)
				break;
		mciSendString("play MUSIC notify",NULL,0,g_hwnd);
		EnableMenuItem(MENU,MENUID_START+MID_PLAY,MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(MENU,MENUID_START+MID_PAUSE,MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(MENU,MENUID_START+MID_STOP,MF_BYCOMMAND | MF_ENABLED);
		break;
	case MID_PAUSE://pause
		mciSendString("pause MUSIC",NULL,0,0);
		EnableMenuItem(MENU,MENUID_START+MID_PLAY,MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(MENU,MENUID_START+MID_PAUSE,MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(MENU,MENUID_START+MID_STOP,MF_BYCOMMAND | MF_ENABLED);
		break;
	case MID_STOP://Stop
		mciSendString("stop MUSIC",NULL,0,0);
		mciSendString("seek MUSIC to start",NULL,0,0);
		EnableMenuItem(MENU,MENUID_START+MID_PLAY,MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(MENU,MENUID_START+MID_PAUSE,MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(MENU,MENUID_START+MID_STOP,MF_BYCOMMAND | MF_GRAYED);
		break;
	}
 return NULL;
}
extern "C" _declspec (dllexport) 
int Setup(HWND ParentWin,	
			void * MFC_ParentWin,
			int a,
			const char * IniFile)
{
	HWND Win = GetActiveWindow();
	int OldLoop = AUTO_LOOP;
	int Ret = DialogBoxParam((HINSTANCE)H_MODULE,MAKEINTRESOURCE(IDD_SETUP),Win,DlgProc,0);
	if (Ret)
		{
		if (OldLoop!=AUTO_LOOP)
			{
			char Temp[2]={'0',0};
			Temp[0]+=AUTO_LOOP;
			WritePrivateProfileString("MIDI","AutoLoop",Temp,INIFILE);
			}
		}
	return Ret;
}
BOOL FAR PASCAL DlgProc(HWND hDlg,UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
		{
		case WM_INITDIALOG:
			if (AUTO_LOOP)
				SendDlgItemMessage(hDlg,IDC_AUTOLOOP,BM_SETCHECK,BST_CHECKED,0);
			break;
		case WM_COMMAND:
			if (wParam == IDCANCEL)
				EndDialog(hDlg,FALSE);
			if (wParam == IDOK)
				{
				AUTO_LOOP = SendDlgItemMessage(hDlg,IDC_AUTOLOOP,BM_GETCHECK,0,0);
				EndDialog(hDlg,TRUE);
				}
			break;
		}
	return FALSE;
}
